#! /usr/local/bin/python -O


import sys, SocketServer


PORT = 8888


class RequestServer(SocketServer.TCPServer):
   allow_reuse_address = 1


class RequestHandler(SocketServer.StreamRequestHandler):
   def handle(self):
      host, port = self.client_address
      print "Connected by", host, port

      # get data
      request = ''

      while 1:
         line = self.rfile.readline()
         if line in (None, "\n", "\r\n"):
            break
         request = request + line

      self.server.request = request

      self.wfile.write("""\
HTTP/1.1 200 Ok
Content-Type: text/plain
Connection: close

Your request has been logged. Thank you. Goodbye.
""")


def main():
   # get port
   if len(sys.argv) > 1:
      port = int(eval(sys.argv[1]))
   else:
      port = PORT

   print "Waiting..."
   server = RequestServer(('', port), RequestHandler)
   server.handle_request() # do not server forever - serve just 1 request

   # store to file
   outfile = open("request.txt", 'w')
   outfile.write(server.request)
   outfile.close()

   print "Done."

main()
